package com.nisum.controller;

import com.nisum.dto.impl.EmployeeDto;
import com.nisum.model.impl.EmployeeImp;
import com.nisum.service.EmployeeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import java.util.Collection;
import java.util.Optional;

@Controller
public class EmployeeController {

  @Autowired
  EmployeeService employeeService;

  @RequestMapping(value = "/", method = RequestMethod.GET)
  public String index(Model model) {
    Collection<EmployeeImp> employeeList = employeeService.getAllEmployees();
    model.addAttribute("employees", employeeList);
    return "index";
  }



  //renders the new form from views
  @RequestMapping(value = "/new", method = RequestMethod.GET)
  public String newEmployee(Model model) {
    model.addAttribute("employee", new EmployeeDto());
    return "new";
  }




  //create a POST request to add new employee
  @RequestMapping(value = "/create", method = RequestMethod.POST)
  public String createEmployee(@ModelAttribute("employee") EmployeeDto employeeDto,
                               BindingResult bindingResult) {
    employeeService.createEmployee(employeeDto);
    return "redirect:/";
  }



  //renders the edit form
  @RequestMapping(value = "/edit", method = RequestMethod.GET)
  public String editEmployee(Model model) {
    model.addAttribute("employee", new EmployeeDto());
    return "new";
  }



  //create a PUT request to edit existing employee
  @RequestMapping(value = "/edit/{id}", method = RequestMethod.GET)
  public String editEmployee(@PathVariable("id") Long id,
                             @RequestBody EmployeeDto employeeDto) {
    employeeService.editEmployee(employeeDto);
//    employeeDto.addAttribute("employee", employee);
    return "edit";
  }





  //create a DELETE request to delete an employee


}
